import os, sys, time
import csv, numpy
from datetime import datetime
import pyexcel
import pyexcel_xlsx

sys.path.insert(0,r'V:\2028\miscellaneous\GSD\Coastal_Tools\ExtremeValueAnalysis\PeaksOverThreshold')
from PeaksOverThreshold import *

# main 	
meter_to_feet = 3.28084
base_dir = os.getcwd()

# load transect information 
tsct_info_file = 'SELFE_Nodes_Clallam_Erosion_MSN.xlsx'
tsct_book = pyexcel.load_book(tsct_info_file)
tsct_info = tsct_book['Nodes'].to_array()[1:]

os.chdir(base_dir+os.sep+'POT_Top100_Erosion')
SWL_POT_filename = "SWL_Top100_ftNAVD88_MSN.csv"
SWL_POT_file = open(SWL_POT_filename, 'wb')
SWL_POT_writer = csv.writer(SWL_POT_file)

DWL_POT_filename = "DWL_Top100_ftNAVD88_MSN.csv"
DWL_POT_file = open(DWL_POT_filename, 'wb')
DWL_POT_writer = csv.writer(DWL_POT_file)

TWL_POT_filename = "TWL_Top100_ftNAVD88_MSN.csv"
TWL_POT_file = open(TWL_POT_filename, 'wb')
TWL_POT_writer = csv.writer(TWL_POT_file)

ts_dir = base_dir + os.sep + "Time_Series_Erosion"

# this was used to save file for checking look up manually
threshold_filename = "threshold_list.txt"
threshold_file = open(threshold_filename, 'wb')

# loop through each transect
for itsct, tsct in enumerate(tsct_info):
    
    if(itsct!=0): continue

    # get tsct_id and the corresponding col in lookup matrix 
    tsct_id = tsct[0]

    print "transect id:", tsct_id

    # open file to save time series of this transect
    os.chdir(ts_dir)
    ts_filename = "TSCT_" + tsct_id + "_TS"  + ".csv"
    ts_data = numpy.genfromtxt(ts_filename, dtype=None, delimiter=",", skiprows=1)     
	
    dates = [ts[0] for ts in ts_data]
    swl_pot = []
    swl_pot.append(tsct_id)
    swl_obs = [ts[1] for ts in ts_data]
    for threshold in numpy.arange(8.0, 12.0, 0.05):
        peak_times, peak_observations, event_times, event_observations = peaks_over_threshold(dates, swl_obs, threshold, 144*3600)                     
        threshold_file.write('threshold = ' + str(threshold)+'\n')
        for rec in peak_times:
            threshold_file.write(str(rec/3600)+'\n')
        if(len(peak_times)<=100):
            threshold_file.write('SWL:' + 'TSCT_ID = ' + tsct_id + ', threshold = ' + str(threshold) + '\n')
            break
    peak_observations.sort(reverse=True)
    for rec in peak_observations:
	swl_pot.append(rec)
	if(len(swl_pot)==101): break
    SWL_POT_writer.writerow(swl_pot)
	
    dwl_pot = []
    dwl_pot.append(tsct_id)
    dwl_obs = [ts[5] for ts in ts_data]
    for threshold in numpy.arange(8.0, 12.0, 0.05):
        peak_times, peak_observations, event_times, event_observations = peaks_over_threshold(dates, dwl_obs, threshold, 144*3600)
        if(len(peak_times)<=100):
            threshold_file.write('DWL:' + 'TSCT_ID = ' + tsct_id + ', threshold = ' + str(threshold) + '\n')
            break    
    peak_observations.sort(reverse=True)
    for rec in peak_observations:
	dwl_pot.append(rec)
	if(len(dwl_pot)==101): break
    DWL_POT_writer.writerow(dwl_pot)	
	
    twl_pot = []
    twl_pot.append(tsct_id)
    twl_obs = [ts[6] for ts in ts_data]
    for threshold in numpy.arange(8.0, 30.0, 0.05):
        peak_times, peak_observations, event_times, event_observations = peaks_over_threshold(dates, twl_obs, threshold, 144*3600)
        if(len(peak_times)<=100):
            threshold_file.write('TWL:' + 'TSCT_ID: ' + tsct_id + ', threshold = ' + str(threshold) + '\n')
            break
    peak_observations.sort(reverse=True)
    for rec in peak_observations:
   	twl_pot.append(rec)
   	if(len(twl_pot)==101): break
    TWL_POT_writer.writerow(twl_pot)

os.chdir(base_dir)
    
# close all files 	
threshold_file.close()
SWL_POT_file.close()
DWL_POT_file.close()
TWL_POT_file.close()
